package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.ClienteCursoDAO;
import com.rjconsultores.ventaboletos.entidad.Cliente;
import com.rjconsultores.ventaboletos.entidad.ClienteCurso;
import com.rjconsultores.ventaboletos.entidad.Curso;

@Repository("clienteCursoDAO")
public class ClienteCursoHibernateDAO extends GenericHibernateDAO<ClienteCurso, Integer>
		implements ClienteCursoDAO {

	@Autowired
	public ClienteCursoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<ClienteCurso> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		return c.list();
	}

	@Override
	public ClienteCurso buscarClienteCurso(Cliente cliente, Curso curso) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("cliente", cliente));
		c.add(Restrictions.eq("curso", curso));

		return (ClienteCurso) c.uniqueResult();
	}

}
